﻿// version 2.5
// by Daved Artemik
// Corrected several sql script issues with the old method of updating metadata and checking if synced
// Updated the page load to prevent auto-sync on Refresh.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;

using System.Security.Principal;
using System.Web.Security;
using System.Runtime.InteropServices;


public partial class SyncMetadataCS : System.Web.UI.Page
{
    public Ektron.Cms.CommonApi api = new Ektron.Cms.CommonApi();
    public Ektron.Cms.DataIO.EkContentRW dataIO;
    enum EWSVersion
    {
        EWS_1 = 1,
        EWS_2 = 2,
        EWS_3 = 3
    }
    public string serverName = "";
    public string ewsStatus = "";

    #region Login and Logout Controls
    public void loginButton_Click(object sender, EventArgs e)
    {
        loginAsUser(username.Text, password.Text);
    }

    public void logoutButton_Click(object sender, EventArgs e)
    {
        logout();
    }

    private void loginAsUser(string user, string pw)
    {
        // custom function for logging in
        Ektron.Cms.CommonApi appUI = new Ektron.Cms.CommonApi();
        Ektron.Cms.API.User.User userAPI = new Ektron.Cms.API.User.User();
        Ektron.Cms.UserData cUser = new Ektron.Cms.UserData();
        string ErrorString = "";
        string serverName = Request.ServerVariables.Get("SERVER_NAME");

        // in case of AD Integration, grab domain name. currently only atttempting
        // first domain name. need to add functionality for multiple
        string domain = "";
        try
        {
            Ektron.Cms.UserAPI uApi = new Ektron.Cms.UserAPI();
            Ektron.Cms.DomainData[] domainList = uApi.GetDomains(0, 1);
            domain = domainList[0].Path.ToString();
        }
        catch (Exception ex) { }
        cUser = userAPI.LogInUser(user, pw, serverName, domain, appUI.AuthProtocol);

        if ((cUser.Id > 0) && (ErrorString == ""))
        {
            if ((Request.Cookies.Get("ecm").Value != "") && (Request.Cookies.Get("ecm").Value != ""))
            {
                // look for the cookie and expire it if it already exists
                Request.Cookies["ecm"].Expires = DateTime.Now.AddDays(-1);
            }
            // set our CMS cookie
            userAPI.SetAuthenticationCookie(cUser);

            HttpCookie cookieEktGUID = null;
            if (Request.Cookies.Get("EktGUID").Value == "")
            {
                // check for GUID cookie and create if need be
                string strGUID = System.Guid.NewGuid().ToString();
                cookieEktGUID = new HttpCookie("EktGUID", strGUID);
                cookieEktGUID.Path = "/";
                cookieEktGUID.Expires = DateTime.Now.AddYears(1);
                Response.Cookies.Add(cookieEktGUID);
                Ektron.Cms.UserAPI refUserApi = new Ektron.Cms.UserAPI();
                refUserApi.RequestInformationRef.ClientEktGUID = strGUID;
            }

            Response.Write("Logged In<br />");
            Response.Redirect(Request.Url.AbsoluteUri);
        }
        else
        {
            Response.Write("Login failed for user: " + user);
        }
        Ektron.Cms.API.User.User ekUser = new Ektron.Cms.API.User.User();
        Int64 userID = ekUser.UserId;
    }

    private void logout()
    {
        try
        {
            if (Session["DDSnip"] != null)
            {
                Session["DDSnip"] = null;
            }
            if (Session["LibCategory"] != null)
            {
                Session["LibCategory"] = null;
            }
            if (Response.Cookies[System.Web.Security.FormsAuthentication.FormsCookieName] != null)
            {
                Response.Cookies[System.Web.Security.FormsAuthentication.FormsCookieName].Expires = DateTime.Now.AddDays(-1);
            }
            Response.Cookies["ecm"].Expires = DateTime.Now.AddDays(-1);
            Response.Cache.SetExpires(DateTime.Now.AddDays(-1));
            Response.Redirect(Request.Url.AbsoluteUri);
        }
        catch (Exception ex) { };
    }
    #endregion

    public SyncMetadataCS()
    {
        serverName = System.Environment.MachineName;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        Ektron.Cms.ContentAPI contentAPI = new Ektron.Cms.ContentAPI();
        if (Session["notSynced"] == null)
        {
            Session.Add("notSynced", 0);
        }
        else
        {
            Session["notSynced"] = 0;
        }
        long userId = api.UserId;
        Ektron.Cms.API.User.User uApi = new Ektron.Cms.API.User.User();
        if (userId > 0)
        {
            Ektron.Cms.UserData uData = uApi.GetUser(userId, false, false);
            if (!uData.IsMemberShip)
            {
                loginDiv.Visible = false;
                loggedIn.Visible = true;
                metaSyncDiv.Visible = true;
                loggedInMsg.Text = "<span style=\"font-size: 12pt;\">Currently logged in as " + uData.Username + "<br />(user id: " + uData.Id + ")</span>" +
                    "<br /><span style=\"font-size: 10pt;\">Time: " + DateTime.Now.ToString("hh:mm tt") + "</span>";
                int loginToken = api.UniqueId;
                int i = 0;
                api.RequestInformationRef.UserId = Ektron.Cms.Common.EkConstants.InternalAdmin;
                api.RequestInformationRef.CallerId = Ektron.Cms.Common.EkConstants.InternalAdmin;
                api.RequestInformationRef.UniqueId = 0;
                api.RequestInformationRef.ContentLanguage = Ektron.Cms.Common.EkConstants.ALL_CONTENT_LANGUAGES;

                dataIO = new Ektron.Cms.DataIO.EkContentRW(api.RequestInformationRef);
                if (!Page.IsPostBack)
                {
                    Microsoft.VisualBasic.Collection mListCol = new Microsoft.VisualBasic.Collection();
                    mListCol = api.EkContentRef.GetMetadataTypes("Name");
                    System.Text.StringBuilder output = new System.Text.StringBuilder();
                    foreach (Microsoft.VisualBasic.Collection metaItem in mListCol)
                    {
                        if ((Ektron.Cms.Common.EkEnumeration.BlogPostDataType)metaItem["ObjectType"] == Ektron.Cms.Common.EkEnumeration.BlogPostDataType.Normal)
                        {
                            i++;
                            output.Append("<tr");
                            if (i % 2 == 0)
                            {
                                output.Append(" class=\"even\"");
                            }
                            else
                            {
                                output.Append(" class=\"odd\"");
                            }
                            output.Append("><td>" + metaItem["MetaTypeName"].ToString() + "</td><td>" + metaItem["MetaTypeID"].ToString() + "</td><td>" + metaItem["MetaLanguage"].ToString() + "</td><td>" + GetStatus(long.Parse(metaItem["MetaTypeID"].ToString()), int.Parse(metaItem["MetaLanguage"].ToString()), metaItem["MetaDefault"].ToString()) + "</td></tr>");
                        }
                    }
                    api.RequestInformationRef.UserId = userId;
                    api.RequestInformationRef.CallerId = userId;
                    api.RequestInformationRef.UniqueId = loginToken;

                    ltMetadataList.Text = output.ToString();
                    Page.ClientScript.RegisterStartupScript(this.GetType(), "wait", "$(document).ready(function(){wait(false);});", true);
                    if ((Session["metaSync"] != null && Session["notSynced"] != null) && (bool)Session["metaSync"] && (int)Session["notSynced"] == 0)
                    {
                        if (!string.IsNullOrEmpty(Request.QueryString["syncAll"]))
                        {
                            Response.Redirect(Request.Url.GetLeftPart(UriPartial.Path));
                        }
                        else
                        {
                            ClientScript.RegisterStartupScript(this.GetType(), "showSyncFinale", "$(document).ready(function() {syncFinale();});", true);
                        }
                    }
                }
                else
                {
                    long metadataId;
                    int lang = 1033;
                    string val = "";
                    if (!string.IsNullOrEmpty(Request.Form["metadataid"]))
                    {
                        long.TryParse(Request.Form["metadataid"].ToString(), out metadataId);
                        if (!string.IsNullOrEmpty(Request.Form["metadataValue"]))
                        {
                            val = Request.Form["metadataValue"].ToString();
                        }
                        if (!string.IsNullOrEmpty(Request.Form["metadataLang"]))
                        {
                            int.TryParse(Request.Form["metadataLang"].ToString(), out lang);
                        }
                        SyncMetadata(metadataId, lang, val);
                    }
                }
                if ((!string.IsNullOrEmpty(Request.QueryString["syncAll"])) && Request.QueryString["syncAll"].ToString() == "t")
                {
                    ClientScript.RegisterStartupScript(this.GetType(), "syncAll", "$(document).ready(function(){syncNext();});", true);
                }
            }
            else
            {
                loginDiv.Visible = true;
                loggedIn.Visible = false;
                metaSyncDiv.Visible = false;
                loginMessage.Text += "You must be a CMS admin to use this page.";
            }
        }
        else
        {
            loginDiv.Visible = true;
            loggedIn.Visible = false;
            metaSyncDiv.Visible = false;
        }
    }

    private string GetStatus(long metaTypeId, int lang, string value)
    {
        string sync = "<img src=\"" + api.RequestInformationRef.AppImgPath + "check20.gif\" alt=\"Synchronized\" />";
        string notSync = "<img src=\"" + api.RequestInformationRef.AppImgPath + "delete2.gif\" alt=\"Not Synchronized\" /><input type=\"button\" onclick=\"sync_metadata(" + metaTypeId + "," + lang + ", '" + value + "');\" value=\"Synchronize\">";
        string ret = sync;
        System.Data.Common.DbDataReader dr = null;
        // this section has been updated to account for the method with which 8.0 metadata is synced.
        string sql = "set nocount on;declare @fId bigint;declare @folders table(folderId bigint);declare @result table(contentId bigint);insert into @folders select distinct cf.folder_id " +
            "from content_folder_tbl cf where cf.inherit_metadata_from in (select distinct cff.folder_id from custom_field_folder_tbl cff where cff.custom_field_set_id = " + metaTypeId + " and cff.lang_id = " + lang + ");" +
            "select top 1 @fId = folderId from @folders;while @@ROWCOUNT > 0 begin;select top 1 @fId = folderId from @folders;insert into @result select distinct c.content_id from content c " +
            "where c.folder_id = @fId and " + metaTypeId + " not in (select meta_type_id from content_meta_tbl where content_id = c.content_id and c.content_language = " + lang + ") and c.content_language = " + lang + ";delete from @folders where folderId = @fId;" +
            "select top 1 @fId = folderId from @folders;end; select * from @result;";
        try
        {
            dr = dataIO.ExecSQLReturnDR(sql, true);
            if (dr.Read())
            {
                ret = notSync;
                if (Session["notSynced"] == null)
                {
                    Session.Add("notSynced", 1);
                }
                else
                {
                    Session["notSynced"] = 1;
                }
            }
        }
        catch (Exception ex) { }
        finally
        {
            if (dr != null)
            {
                dr.Close();
            }
        }
        sql = "select c.content_id from content_meta_tbl cm join content c on cm.content_id = c.content_id where c.folder_id in (select distinct folder_id from content_folder_tbl where inherit_metadata_from in (select distinct folder_id from custom_field_folder_tbl where custom_field_set_id = " + metaTypeId + ")) and cm.active = 0 and meta_type_id = " + metaTypeId + " and c.content_language = " + lang;
        try
        {
            dr = dataIO.ExecSQLReturnDR(sql, true);
            if (dr.Read())
            {
                ret = notSync;
                if (Session["notSynced"] == null)
                {
                    Session.Add("notSynced", 1);
                }
                else
                {
                    Session["notSynced"] = 1;
                }
            }
        }
        catch (Exception ex) { }
        finally
        {
            if (dr != null)
            {
                dr.Close();
            }
        }
        return ret;
    }

    private void SyncMetadata(long metaTypeId, int language, string value)
    {
        string sql = "select content_id, content_language from content where content_id NOT IN (select content_id from content_meta_tbl where meta_type_id = " + metaTypeId + " and content_language = " + language + ") and folder_id in (select distinct cf.folder_id from content_folder_tbl cf where cf.inherit_metadata_from in (select distinct cff.folder_id from custom_field_folder_tbl cff where cff.custom_field_set_id = " + metaTypeId + " and cff.lang_id = " + language + "))";
        string template = "INSERT INTO content_meta_tbl (meta_type_id,content_id,content_language,meta_value,active)VALUES(" + metaTypeId + ",{0},{1},N'" + value + "',1)";
        System.Data.Common.DbDataReader dr = null;
        System.Collections.ArrayList exeSql = new System.Collections.ArrayList();
        bool bRet = false;
        try
        {
            dr = dataIO.ExecSQLReturnDR(sql, true);
            while (dr.Read())
            {
                if (int.Parse(dr["content_language"].ToString()) == language)
                {
                    exeSql.Add(string.Format(template, dr["content_id"], dr["content_language"]));
                }
            }
            foreach (string strExec in exeSql)
            {
                dataIO.ExecSQL(strExec);
            }
            dataIO.ExecSQL("update content_meta_tbl set active=1 where content_id in (select c.content_id from content_meta_tbl cm join content c on cm.content_id = c.content_id where c.folder_id in (select distinct folder_id from content_folder_tbl where inherit_metadata_from in (select distinct folder_id from custom_field_folder_tbl where custom_field_set_id = " + metaTypeId + ")) and cm.active = 0 and meta_type_id = " + metaTypeId + " and c.content_language = " + language + ") and content_language = " + language);
            if (Session["metaSync"] == null)
            {
                Session.Add("metaSync", true);
            }
            else
            {
                Session["metaSync"] = true;
            }
            bRet = true;

        }
        catch (Exception ex)
        {
            Response.Redirect("reterror.aspx?info=" + Server.UrlEncode(ex.Message), false);
        }
        finally
        {
            if (dr != null)
            {
                dr.Close();
            }
        }
        if (bRet)
        {
                Response.Redirect(Request.Url.ToString(), false);
        }
    }

    #region Helper Functions

    public void restartEws(Object sender, EventArgs e)
    {
        string status = string.Empty;
        if (uName.Text != null && pWord.Text != null)
        {
            Ektron.Cms.CommonApi comApi = new Ektron.Cms.CommonApi();
            if (!restartEWS(double.Parse(comApi.Version), out status))
            {
                ewsStatus = "<span style=\"color:red; font-weight: bold;\">Failed</span>";
                status = "Failed to restart Ektron Windows Service.\r\nStatus Log:<div class=\"diag_StatusLog\">" + status + "</div>";
            }
            else
            {
                ewsStatus = "<span style=\"color:green; font-weight: bold;\">Success</span>";
                status = "Ektron Windows Service successfully restarted.\r\nStatus Log:<div class=\"diag_StatusLog\">" + status + "</div>";
                if (Session["metaSync"] != null)
                {
                    Session["metaSync"] = false;
                }
                else
                {
                    Session.Add("metaSync", false);
                }
            }
        }
        else
        {
            status = "<span style=\"color:red;\">Username and Password are both required.</span>";
        }
        ClientScript.RegisterStartupScript(this.GetType(), "confirmSyncComplete", "$(document).ready(function(){$('.diag_Log').html('" + status.Replace("\r\n", "<br />") +
            "'); $().colorbox({inline: true, title: 'Status', href: '#statusDiag', onComplete: function () {$('#form1').append($('#colorbox'));}, onClosed: function(){window.location.href = '" + Request.Url.GetLeftPart(UriPartial.Path) + "';}});});", true);
    }
    private bool restartEWS(double version, out string statusOut)
    {
        try
        {
            string serviceName = string.Empty;
            statusOut = string.Empty;

            version = double.Parse(version.ToString().Replace(".", ""));

            if (version >= 80)
            {
                serviceName = getServiceName(EWSVersion.EWS_3);
            }
            else if (version < 80 && version >= 75)
            {
                serviceName = getServiceName(EWSVersion.EWS_2);
            }
            else if (version < 75 && version >= 70)
            {
                serviceName = getServiceName(EWSVersion.EWS_1);
            }
            if (serviceName != string.Empty)
            {
                ServiceHandler serviceApi = new ServiceHandler(uName.Text.Trim(), pWord.Text.Trim());
                if (clearPerformAction() && clearAssetServerTable())
                {
                    if (serviceApi.RestartWindowsService(serviceName, out statusOut))
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    statusOut = "Failed to clear perform_action table.\r\n" + statusOut;
                    return false;
                }
            }
            else
            {
                statusOut = "Service not found.";
                return false;
            }
        }
        catch (Exception ex)
        {
            statusOut = (ex.Message == string.Empty ? ex.ToString() : ex.Message);
            return false;
        }
    }
    private string getServiceName(EWSVersion version)
    {
        List<string> ewsList = getEktronWindowsServices();
        string result = string.Empty;
        foreach (string item in ewsList)
        {
            if (version != EWSVersion.EWS_1)
            {
                if (item.Contains(((int)version).ToString()) || item.Contains(((int)version).ToString("N1")))
                {
                    return item;
                }
            }
            else
            {
                if (!item.Contains(((int)EWSVersion.EWS_3).ToString()) && !item.Contains(((int)EWSVersion.EWS_3).ToString("N1"))
                    && !item.Contains(((int)EWSVersion.EWS_2).ToString()) && !item.Contains(((int)EWSVersion.EWS_2).ToString("N1")))
                {
                    return item;
                }
            }
        }
        return result;
    }
    private List<string> getEktronWindowsServices()
    {
        List<string> serviceList = new List<string>();
        System.Management.ManagementObjectSearcher mos = new System.Management.ManagementObjectSearcher();
        mos.Query = new System.Management.ObjectQuery("SELECT * FROM win32_service where name like 'Ektron%'");
        foreach (System.Management.ManagementObject mo in mos.Get())
        {
            if (mo["Name"].ToString().ToLower().Contains("windows"))
            {
                serviceList.Add(mo["Name"].ToString());
            }
        }
        return serviceList;
    }
    private bool clearPerformAction()
    {
        string sql = "delete from perform_action";
        try
        {
            dataIO.ExecSQL(sql);
            return true;
        }
        catch (Exception ex)
        {
            return false;
        }
    }
    private bool clearAssetServerTable()
    {
        string sql = "delete from AssetServerTable where siteAddress = '" + Request.ServerVariables.Get("SERVER_NAME") + "'";
        try
        {
            dataIO.ExecSQL(sql);
            return true;
        }
        catch (Exception ex)
        {
            return false;
        }
    }
    #endregion

    public class ServiceHandler
    {
        private string _userName = "";
        private string _passWord = "";
        public const int LOGON32_LOGON_INTERACTIVE = 2;
        public const int LOGON32_PROVIDER_DEFAULT = 0;

        WindowsImpersonationContext impersonationContext;

        [DllImport("advapi32.dll")]
        public static extern int LogonUserA(String lpszUserName,
            String lpszDomain,
            String lpszPassword,
            int dwLogonType,
            int dwLogonProvider,
            ref IntPtr phToken);
        [DllImport("advapi32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern int DuplicateToken(IntPtr hToken,
            int impersonationLevel,
            ref IntPtr hNewToken);

        [DllImport("advapi32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern bool RevertToSelf();

        [DllImport("kernel32.dll", CharSet = CharSet.Auto)]
        public static extern bool CloseHandle(IntPtr handle);

        public ServiceHandler(string username, string password)
        {
            _userName = username;
            _passWord = password;
            if (!impersonateValidUser())
            {
                throw new Exception("Invalid username or password.");
            }
            else
            {
                undoImpersonation();
            }
        }

        #region Manage Windows Services
        public bool RestartWindowsService(string serviceName, out string statusMsg)
        {
            System.Text.StringBuilder status = new System.Text.StringBuilder();
            int milliTimeOut = 60000;
            int mSeconds1 = Environment.TickCount;
            TimeSpan timeOut = TimeSpan.FromMilliseconds(milliTimeOut);

            try
            {
                if (impersonateValidUser())
                {
                    System.ServiceProcess.ServiceController controller = new System.ServiceProcess.ServiceController(serviceName);
                    status.Append("ServiceController created.\r\n");
                    // Application hosted on IIS that supports App Pools, like 6.0 and 7.0
                    if (controller.Status == System.ServiceProcess.ServiceControllerStatus.Running)
                    {
                        status.Append(serviceName + " is running.\r\n");
                        controller.Stop();
                        status.Append("Stopping service.\r\n");
                        controller.WaitForStatus(System.ServiceProcess.ServiceControllerStatus.Stopped, timeOut);
                        status.Append("Service stopped.\r\n");

                        int mSeconds2 = Environment.TickCount;
                        timeOut = TimeSpan.FromMilliseconds(milliTimeOut - (mSeconds2 - mSeconds1));

                        controller.Start();
                        status.Append("Starting Service.\r\n");
                        controller.WaitForStatus(System.ServiceProcess.ServiceControllerStatus.Running, timeOut);
                        status.Append("Service started.\r\n");
                        statusMsg = status.ToString();
                        return true;
                    }
                    else
                    {
                        status.Append(serviceName + " is not currently running.\r\n");
                        controller.Start();
                        status.Append("Starting Service.\r\n");
                        controller.WaitForStatus(System.ServiceProcess.ServiceControllerStatus.Running, timeOut);
                        status.Append("Service started.\r\n");
                        statusMsg = status.ToString();
                        return true;
                    }

                }
                else
                {
                    statusMsg = "User credentials failed.\r\n";
                    return false;
                }
            }
            catch (Exception ex)
            {
                statusMsg = ex.Message + "Status Log:" + status.ToString() + "\r\n";
                return false;
            }
            finally
            {
                undoImpersonation();
            }
        }
        #endregion

        #region Impersonate user
        private bool impersonateValidUser()
        {
            WindowsIdentity tempWindowsIdentity;
            IntPtr token = IntPtr.Zero;
            IntPtr tokenDuplicate = IntPtr.Zero;

            if (RevertToSelf())
            {
                if (LogonUserA(_userName, "", _passWord, LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, ref token) != 0)
                {
                    if (DuplicateToken(token, 2, ref tokenDuplicate) != 0)
                    {
                        tempWindowsIdentity = new WindowsIdentity(tokenDuplicate);
                        impersonationContext = tempWindowsIdentity.Impersonate();
                        if (impersonationContext != null)
                        {
                            CloseHandle(token);
                            CloseHandle(tokenDuplicate);
                            return true;
                        }
                    }
                }
            }
            if (token != IntPtr.Zero)
                CloseHandle(token);
            if (tokenDuplicate != IntPtr.Zero)
                CloseHandle(tokenDuplicate);
            return false;
        }
        private void undoImpersonation()
        {
            if (impersonationContext != null)
                impersonationContext.Undo();
        }
        #endregion
    }

}

